import { defineComponent as x, computed as $, ref as y, shallowRef as A, onMounted as B, watch as L, createVNode as a, resolveComponent as C, mergeProps as p, toRef as N, unref as I, Fragment as q, nextTick as z, isVNode as G } from "vue";
import { formProps as H, formEmits as J } from "./props.js";
import { dialogProps as Q, dialogEmits as W, ElCol as P, ElFormItem as T } from "element-plus";
import { pickObjByKeys as m, firstUppercase as X, deepClone as Y, omitObjByKeys as Z } from "@tomiaa/utils";
import { KCustomElement as O } from "../../customElement/index.js";
import { Toolbar as ee, Editor as oe } from "@wangeditor/editor-for-vue";
import "../../node_modules/.pnpm/@wangeditor_editor@5.1.18/node_modules/@wangeditor/editor/dist/css/style.js";
function le(o) {
  return typeof o == "function" || Object.prototype.toString.call(o) === "[object Object]" && !G(o);
}
const ue = x({
  name: "KForm",
  props: H,
  emits: J,
  setup(o, {
    attrs: v,
    slots: u,
    emit: s,
    expose: _
  }) {
    const g = o.modelValue !== void 0, D = $(() => m(o, Object.keys(Q))), w = {};
    for (const e in W)
      w["on" + X(e)] = () => s(e);
    const d = y(), K = () => {
      var e;
      return a(C("el-dialog"), p({
        ref: d
      }, w, {
        "onUpdate:modelValue": (l) => s("update:modelValue", l),
        onClosed: o.destroyOnClose && ((e = r.value) == null ? void 0 : e.resetFields)
      }, D.value), {
        footer: o.showActions ? F : void 0,
        ...u,
        default: k
      });
    }, F = () => {
      var l, n, i, R;
      let e = [{
        el: "el-button",
        type: "primary",
        "v-if": o.actionsConfig.showSubmit,
        onClick() {
          var E, M;
          const c = {
            formRef: r,
            dialogRef: d,
            formModel: t,
            validate: (E = r.value) == null ? void 0 : E.validate,
            rawFormModel: b()
          };
          if (o.autoValidateOnSubmit) {
            (M = r.value) == null || M.validate((U) => {
              s(U ? "submit" : "submitCheckFail", c);
            });
            return;
          }
          s("submit", c);
        },
        children: (l = o.actionsConfig.submitText) != null ? l : "\u63D0\u4EA4"
      }, {
        el: "el-button",
        "v-if": o.actionsConfig.showReset,
        onClick() {
          var c;
          r.value.resetFields(), s("reset", {
            formRef: r,
            dialogRef: d,
            formModel: t,
            validate: (c = r.value) == null ? void 0 : c.validate,
            rawFormModel: b()
          });
        },
        children: (n = o.actionsConfig.resetText) != null ? n : "\u91CD\u7F6E"
      }, {
        el: "el-button",
        "v-if": o.actionsConfig.showCancel,
        onClick() {
          s("update:modelValue", !1), s("cancel");
        },
        children: (i = o.actionsConfig.cancelText) != null ? i : "\u53D6\u6D88"
      }];
      return (R = o.actionsConfig) != null && R.custom && (e = o.actionsConfig.custom(e)), g ? a(O, {
        list: e
      }, null) : a(P, o.actionsConfig, {
        default: () => [a(T, null, {
          default: () => [a(O, {
            list: e
          }, null)]
        })]
      });
    }, r = y(), t = y({}), j = () => {
      o.options.forEach((e) => {
        if (e.prop && typeof e.prop == "string") {
          const l = e.el === "el-upload" ? "fileList" : "modelValue";
          t.value[e.prop] = N(e, l);
        }
      });
    };
    j();
    const b = () => {
      const e = {};
      for (const l in t.value)
        e[l] = I(t.value[l]);
      return e;
    }, k = () => a(C("el-form"), p(v, {
      ref: r,
      model: t.value
    }), {
      default: () => [a(C("el-row"), v, {
        default: () => [o.options.map((e) => {
          const l = e.el === "el-upload" ? "fileList" : "modelValue";
          let n = {
            ...m(e, Object.keys(P.props)),
            class: e.class ? `${e.class}__el-col` : "",
            el: "el-col",
            children: {
              ...m(e, Object.keys(T.props)),
              class: e.class ? `${e.class}__el-form-item` : "",
              el: "el-form-item",
              children: {
                ...e,
                [l]: t.value[e.prop],
                [`onUpdate:${l}`](i) {
                  Object.prototype.hasOwnProperty.call(t.value, e.prop) && (t.value[e.prop] = i);
                }
              }
            }
          };
          return ["", !1].includes(v.inline) && (n = n.children), e.el === "editor" && (n.children.children = S(e)), a(O, {
            list: n
          }, le(u) ? u : {
            default: () => [u]
          });
        }), o.showActions && !g && F()]
      })]
    }), f = A({}), S = (e) => (e.prop && !f.value[e.prop] && (f.value[e.prop] = A()), a(q, null, [a(ee, p({
      style: "border-bottom: 1px solid #ccc",
      mode: "default",
      editor: e.prop && f.value[e.prop].value
    }, e.editorAttrs), null), a(oe, p({
      style: "height: 300px; width: 100%; overflow-y: hidden",
      mode: "default",
      modelValue: t.value[e.prop],
      "onUpdate:model-value": (l) => {
        Object.prototype.hasOwnProperty.call(t.value, e.prop) && (t.value[e.prop] = l);
      },
      onOnCreated: (l) => {
        e.prop && (f.value[e.prop].value = l);
      }
    }, e.toolbarAttrs), null)])), h = {
      initFormModel: j,
      getRawFormModel: b,
      setFormModel: (e, {
        includes: l = [],
        exclude: n = []
      } = {}) => {
        e = Y(e);
        let i = l != null && l.length ? m(e, l) : e;
        n != null && n.length && (i = Z(i, n)), Object.assign(t.value, i);
      },
      getFormRef: () => r,
      getDialogRef: () => d,
      formModel: t
    }, V = async () => {
      await z(), Object.assign(h, r.value), Object.assign(h, d.value);
    };
    return B(V), L(() => o.modelValue, V), _(h), () => a("div", null, [g ? K() : k()]);
  }
});
export {
  ue as default
};
